//****************************************************************************
//	aisa54s.pas
//
//	aISA-P54W/H
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/03/05
//
//	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
//
//****************************************************************************
unit aisa54s;

interface

uses
	Windows, Messages, SysUtils, Forms, aisa54w;

const
	szTitle = 'Sample';
	szP54W = 'aISA-P54W';
	szP54H = 'aISA-P54H';

type
	TForm1 = class(TForm)
		procedure FormCreate(Sender: TObject);
	private
		procedure ResultMessage(strbuf: String);
		procedure ErrorMessage(wLogSlot: Word);
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
	strbuf:	 String;
	strName: String;
	dwDLLVer, dwDrvVer: DWord;
	bResult:	Boolean;				// 
	wLogSlot: Word;						// foCXi[
	dwMaxPorts:		DWord;			// |[g̐
	dwDirections: DWord;			// fBNV
	InValue:	Byte;
	OutValue: Byte;
	ri:				TAISA54RESOURCE;	// \[X
begin
//---------------------------------------------------------------------------
	// aisa54.dll ̎gp錾
	if Aisa54wDllOpen() = False then
	begin
		ErrorMessage(AISA54_SLOT_AUTO);
		Exit;			// aisa54.dll ̃[hɎs܂
	end;

//---------------------------------------------------------------------------
	// o[Wԍ\
	// aISA-P54W/H DLL,Driver̃o[Wԍ擾
	if Aisa54wGetVersion(dwDLLVer, dwDrvVer) = False then
	begin
		ErrorMessage(AISA54_SLOT_AUTO);
		Exit;
	end;

	strbuf := Format('GetVersion'#10 +
					 'DLL Version: %08xH'#10 +
					 'Drv Version: %08xH',
										 [dwDLLVer, dwDrvVer]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// aISA-P54W/H̎gp錾
	wLogSlot := AISA54_SLOT_AUTO;				// gp̃foCXT܂B
	bResult := Aisa54wCreate(wLogSlot);	// ꍇA̎̃foCXi[܂B

	if bResult = False then		// foCX܂B
	begin
		ErrorMessage(AISA54_SLOT_AUTO);
		Exit;
	end;

	strbuf := Format('aISA-P54W/H Created'#10#10 +
									 'LogSlot: %2d', [wLogSlot]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// |[g擾
	if Aisa54wGetNumPorts(wLogSlot, dwMaxPorts) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

//---------------------------------------------------------------------------
	// foCX̎
	if dwMaxPorts = AISA54_MAX_PORT_W then
		strName := szP54W		// aISA-P54W
	else
		strName := szP54H;	// aISA-P54H

//---------------------------------------------------------------------------
	// \[X擾
	if Aisa54wGetResource(wLogSlot, @ri) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('Board Name: %s'#10 +
						 'NumPorts: %2d'#10 +
						 'IO Address: %04xH-%04xH',
										 [strName, dwMaxPorts,
											ri.dwIOPortBase[1],
											ri.dwIOPortBase[1] + ri.dwIOPortLength[1] - 1]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// A Port ̃fBNVo͂ɐݒ
	// fBNV擾
	if Aisa54wGetDirections(wLogSlot, dwDirections) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	// A Port ̃rbgo͂ɕύX܂B
	dwDirections := not(AISA54_DIR_A_INPUT) and dwDirections;

	// fBNVZbg
	if Aisa54wSetDirections(wLogSlot, dwDirections) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('A Port̃fBNVo͂ɕύX');

//---------------------------------------------------------------------------
	// A Port ɔCӂ̃f[^o
	// o̓f[^ AAh
	OutValue := Byte($AA);

	if Aisa54wOutPort(wLogSlot, AISA54_PORT_A, OutValue) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('A Portփf[^o'#10 +
					 'A Port Out Data: %02xH',
					 [OutValue]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// A Port f[^ǂݍ
	InValue := Byte($00);

	if Aisa54wInPort(wLogSlot, AISA54_PORT_A, InValue) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('A Portf[^'#10 +
					 'A Port In Data: %02xH',
					 [InValue]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// A Port ̃fBNV͂ɐݒ
	// fBNV擾
	if Aisa54wGetDirections(wLogSlot, dwDirections) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	// A Port ̃rbg͂ɕύX܂B
	dwDirections := AISA54_DIR_A_INPUT or dwDirections;

	// fBNVZbg
	if Aisa54wSetDirections(wLogSlot, dwDirections) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('A Port̃fBNV͂ɕύX');

//---------------------------------------------------------------------------
	// A Port f[^ǂݍ
	InValue := Byte($00);

	if Aisa54wInPort(wLogSlot, AISA54_PORT_A, InValue) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('A Portf[^'#10 +
					 'A Port In Data: %02xH',
					 [InValue]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// aISA-P54W/H̎gpJ
	if Aisa54wClose(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('aISA-P54W/H Closed');

	// aisa54.dll ̎gpJ
	if Aisa54wDllClose() = False then
	begin
		Application.MessageBox(PChar('DLL ̃A[hɎs܂B'), szTitle, MB_OK + MB_ICONSTOP);
		Exit;			// aisa54.dll ̃A[hɎs܂B
	end;

end;

// ʂ\
procedure TForm1.ResultMessage(strbuf: String);
begin
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;

// G[bZ[W\
procedure TForm1.ErrorMessage(wLogSlot: Word);
var
	dwRes: DWord;
	strbuf: String;
begin
	dwRes := Aisa54wGetLastError(wLogSlot);

	case dwRes of
		AISA54_ERR_SYSTEM:
			strbuf := Format('System error'#10#10'Error code: %08xH', [GetLastError()]);

		AISA54_ERR_WRAPDLL:
			strbuf := 'DLL Load error';
	else
		strbuf := Format('aISA-P54W/H error'#10#10'Error code: %08xH',[dwRes]);
	end;

	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.
