Attribute VB_Name = "Sample"
'*****************************************************************************
'* aisa54s.bas                                                               *
'*                                                                           *
'* aISA-P54W/H                                                           *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date 1998/03/11                                                           *
'*                                                                           *
'*  ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B                   *
'*                                                                           *
'*****************************************************************************
Option Explicit

Private Const szP54W = "aISA-P54W"
Private Const szP54H = "aISA-P54H"

Private Declare Function GetLastError Lib "kernel32" () As Long


Sub Main()

    Dim strbuf As String
    Dim strName As String
    Dim dwDllVer As Long, dwDrvVer As Long
    Dim bResult As Boolean              ' 
    Dim wLogSlot As Integer             ' foCXi[
    Dim dwMaxPorts As Long              ' |[g̐
    Dim dwDirections As Long            ' fBNV
    Dim InValue As Byte
    Dim OutValue As Byte
    Dim ri As AISA54RESOURCE            ' \[X

'---------------------------------------------------------------------------
    ' aisa54.dll ̎gp錾
    If Aisa54wDllOpen() = False Then
        ErrorMessage (AISA54_SLOT_AUTO)
        Exit Sub                ' aisa54.dll ̃[hɎs܂
    End If

'---------------------------------------------------------------------------
    ' o[Wԍ\
    If Aisa54wGetVersion(dwDllVer, dwDrvVer) = False Then ' aISA-P54W/HDLL,Driver̃o[Wԍ擾
        ErrorMessage (AISA54_SLOT_AUTO)
        Exit Sub
    End If

    strbuf = "GetVersion" + Chr(10) + _
             "DLL Version: &H" + Hex(dwDllVer) + Chr(10) + _
             "Drv Version: &H" + Hex(dwDrvVer)
    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aISA-P54W/H̎gp錾
    wLogSlot = AISA54_SLOT_AUTO       ' gp̃foCXT܂B
    bResult = Aisa54wCreate(wLogSlot) ' ꍇA̎̃foCXi[܂B

    If bResult = False Then           ' foCX܂B
        ErrorMessage (AISA54_SLOT_AUTO)
        Exit Sub
    End If

    strbuf = "aISA-P54W/H Created" + Chr(10) + Chr(10) + _
          "LogSlot: " + Str(wLogSlot)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' |[g擾
    If Aisa54wGetNumPorts(wLogSlot, dwMaxPorts) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

'---------------------------------------------------------------------------
    ' foCX̎
    If dwMaxPorts = AISA54_MAX_PORT_W Then
        strName = szP54W   ' aISA-P54W
    Else
        strName = szP54H   ' aISA-P54H
    End If

'---------------------------------------------------------------------------
    ' \[X擾
    If Aisa54wGetResource(wLogSlot, ri) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "Board Name: " + strName + Chr(10) + _
             "NumPorts: " + Str(dwMaxPorts) + Chr(10) + _
             "IO Address: &H" + Hex(ri.dwIOPortBase(1)) + _
             "-&H" + Hex(ri.dwIOPortBase(1) + ri.dwIOPortLength(1) - 1)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' A Port ̃fBNVo͂ɐݒ
    ' fBNV擾
    If Aisa54wGetDirections(wLogSlot, dwDirections) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ' A Port ̃rbgo͂ɕύX܂B
    dwDirections = (Not AISA54_DIR_A_INPUT) And dwDirections

    ' fBNVZbg
    If Aisa54wSetDirections(wLogSlot, dwDirections) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("A Port̃fBNVo͂ɕύX")

'---------------------------------------------------------------------------
    ' A Port ɔCӂ̃f[^o
    ' &HAA -> 10101010
    OutValue = &HAA

    If Aisa54wOutPort(wLogSlot, AISA54_PORT_A, OutValue) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "A Portփf[^o" + Chr(10) + _
             "A Port Out Data: &H" + Hex(OutValue)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' A Port f[^ǂݍ
    InValue = &H0

    If Aisa54wInPort(wLogSlot, AISA54_PORT_A, InValue) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "A Portf[^" + Chr(10) + _
             "A Port In Data: &H" + Hex(InValue)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' A Port ̃fBNV͂ɐݒ
    ' fBNV擾
    If Aisa54wGetDirections(wLogSlot, dwDirections) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ' A Port ̃rbg͂ɕύX܂B
    dwDirections = AISA54_DIR_A_INPUT Or dwDirections

    ' fBNVZbg
    If Aisa54wSetDirections(wLogSlot, dwDirections) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("A Port̃fBNV͂ɕύX")

'---------------------------------------------------------------------------
    ' A Port f[^ǂݍ
    InValue = &H0

    If Aisa54wInPort(wLogSlot, AISA54_PORT_A, InValue) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "A Portf[^" + Chr(10) + _
             "A Port In Data: &H" + Hex(InValue)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aISA-P54W/H̎gpJ
    If Aisa54wClose(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("aISA-P54W/H Closed")

'---------------------------------------------------------------------------
    ' aisa54.dll ̎gpJ
    If Aisa54wDllClose() = False Then
        MsgBox "DLL ̃A[hɎs܂B", vbOKOnly + vbCritical
        Exit Sub        ' aisa54.dll ̃A[hɎs܂B
    End If

End Sub

' ʂ\
Private Sub ResultMessage(lpszbuf As String)

    MsgBox lpszbuf, vbOKOnly + vbInformation

End Sub


' G[bZ[W\
Private Sub ErrorMessage(wLogSlot As Integer)

    Dim dwRes As Long
    Dim szbuf As String

    dwRes = Aisa54wGetLastError(wLogSlot)

    Select Case dwRes
    Case AISA54_ERR_SYSTEM
        szbuf = "System error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(GetLastError())

    Case AISA54_ERR_WRAPDLL
        szbuf = "DLL Load error"

    Case Else                           ' ̑̒l̏ꍇB
        szbuf = "aISA-P54W/H error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwRes)
    End Select

    MsgBox szbuf, vbOKOnly + vbCritical

End Sub
