/******************************************************************************/
/*	aisa54s.c																  */
/*																			  */
/*	aISA-P54W/H															  */
/*																			  */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									  */
/*																			  */
/*	Date 1998/03/05															  */
/*																			  */
/*	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B					  */
/*																			  */
/******************************************************************************/


#define	STRICT
#include	<windows.h>
#include	<tchar.h>

#include "aisa54w.h"


const TCHAR szTitle[] = _T("Sample");
const TCHAR szP54W[] = _T("aISA-P54W");
const TCHAR szP54H[] = _T("aISA-P54H");

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	TCHAR szbuf[256];
	TCHAR szName[50];
	DWORD dwDLLVer, dwDrvVer;
	BOOL  bResult;					// 
	WORD  wLogSlot;					// foCXi[
	DWORD dwMaxPorts;				// |[g̐
	DWORD dwDirections;				// fBNV
	BYTE  InValue, OutValue;
	AISA54RESOURCE ri;				// \[X

/*---------------------------------------------------------------------------*/
	// aisa54.dll ̎gp錾
	if (Aisa54wDllOpen() == FALSE)
	{
		ErrorMessage(AISA54_SLOT_AUTO);
		return 1;			// aisa54.dll ̃[hɎs܂
	}

/*---------------------------------------------------------------------------*/
	// o[Wԍ\
	// aISA-P54W/H DLL,Driver̃o[Wԍ擾
	if (Aisa54wGetVersion(&dwDLLVer, &dwDrvVer) == FALSE)
	{
		ErrorMessage(AISA54_SLOT_AUTO);
		return 1;
	}

	wsprintf(szbuf, _T("GetVersion\n")
					_T("DLL Version: %08lxh\n")
					_T("Drv Version: %08lxh"),
					dwDLLVer,
					dwDrvVer);
	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// aISA-P54W/H̎gp錾
	wLogSlot = AISA54_SLOT_AUTO;		// gp̃foCXT܂B
	bResult = Aisa54wCreate(&wLogSlot);	// ꍇA̎̃foCXi[܂B

	if (bResult == FALSE)		// foCX܂B
	{
		ErrorMessage(AISA54_SLOT_AUTO);
		return 1;
	}

	wsprintf(szbuf, _T("aISA-P54W/H Created\n\n")
					_T("LogSlot: %2d"),
					 wLogSlot);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// |[g擾
	if (Aisa54wGetNumPorts(wLogSlot, &dwMaxPorts) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

/*---------------------------------------------------------------------------*/
	// foCX̎
	if (dwMaxPorts == AISA54_MAX_PORT_W)
		lstrcpy(szName, szP54W);	// aISA-P54W
	else
		lstrcpy(szName, szP54H);	// aISA-P54H

/*---------------------------------------------------------------------------*/
	// \[X擾
	if (Aisa54wGetResource(wLogSlot, &ri) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("Board Name: %s\n")
					_T("NumPorts: %2d\n")
					_T("IO Address: %04xh-%04xh"),
					szName,
					dwMaxPorts,
					ri.dwIOPortBase[0], ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// A Port ̃fBNVo͂ɐݒ
	// fBNV擾
	if (Aisa54wGetDirections(wLogSlot, &dwDirections) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	// A Port ̃rbgo͂ɕύX܂B
	dwDirections = ~AISA54_DIR_A_INPUT & dwDirections;

	// fBNVZbg
	if (Aisa54wSetDirections(wLogSlot, dwDirections) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage(_T("A Port̃fBNVo͂ɕύX"));

/*---------------------------------------------------------------------------*/
	// A Port ɔCӂ̃f[^o
	// o̓f[^ AAh
	OutValue = (BYTE)0xAA;

	if (Aisa54wOutPort(wLogSlot, AISA54_PORT_A, OutValue) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("A Portփf[^o\n")
					_T("A Port Out Data: %02xh"),
					 OutValue);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// A Port f[^ǂݍ
	InValue = (BYTE)0x00;

	if (Aisa54wInPort(wLogSlot, AISA54_PORT_A, &InValue) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("A Portf[^\n")
					_T("A Port In Data: %02xh"),
					 InValue);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// A Port ̃fBNV͂ɐݒ
	// fBNV擾
	if (Aisa54wGetDirections(wLogSlot, &dwDirections) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	// A Port ̃rbg͂ɕύX܂B
	dwDirections = AISA54_DIR_A_INPUT | dwDirections;

	// fBNVZbg
	if (Aisa54wSetDirections(wLogSlot, dwDirections) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage(_T("A Port̃fBNV͂ɕύX"));

/*---------------------------------------------------------------------------*/
	// A Port f[^ǂݍ
	InValue = (char)0x00;

	if (Aisa54wInPort(wLogSlot, AISA54_PORT_A, &InValue) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("A Portf[^\n")
					_T("A Port In Data: %02xh"),
					 InValue);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// aISA-P54W/H̎gpJ
	if (Aisa54wClose(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage(_T("aISA-P54W/H Closed"));

/*---------------------------------------------------------------------------*/
	// aisa54.dll ̎gpJ
	if (Aisa54wDllClose() == FALSE)
	{
		MessageBox(NULL, _T("DLL ̃A[hɎs܂B"), szTitle, MB_OK | MB_ICONSTOP);
		return 1;			// aisa54.dll ̃A[hɎs܂B
	}

	return 0;
}

// ʂ\
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}

// G[bZ[W\
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Aisa54wGetLastError(wLogSlot);
	TCHAR szbuf[50];

	switch (dwRes)
	{
		case AISA54_ERR_SYSTEM:
			wsprintf(szbuf, _T("System error\n\n")
							_T("Error code: %08lxh"),
							GetLastError());
			break;

		case AISA54_ERR_WRAPDLL:
			wsprintf(szbuf, _T("DLL Load error"));
			break;

		default:
			wsprintf(szbuf, _T("aISA-P54W/H error\n\n")
							_T("Error code: %08lxh"),
							dwRes);
			break;
	}

	MessageBox(NULL, szbuf, szTitle, MB_OK | MB_ICONSTOP);
}
