/*****************************************************************************/
/*	aisa54w.c																 */
/*																			 */
/*	aISA-P54W/H															 */
/*																			 */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									 */
/*																			 */
/*	Date 1998/03/05															 */
/*																			 */
/*****************************************************************************/

#include <windows.h>
#include <tchar.h>

#include "aisa54w.h"	// aISA-P54W/H

/*---------- X^eBbN֐ -----------------------------------------------*/
static BOOL Aisa54wGetDllExportFunc();


/*---------- X^eBbNϐ(萔) -----------------------------------------*/
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[ϐ
static FARPROC pAisa54GetVersion;
static FARPROC pAisa54Create;
static FARPROC pAisa54Close;
static FARPROC pAisa54GetNumPorts;
static FARPROC pAisa54GetResource;
static FARPROC pAisa54GetDirections;
static FARPROC pAisa54SetDirections;
static FARPROC pAisa54InPort;
static FARPROC pAisa54OutPort;
static FARPROC pAisa54GetLastError;


/*****************************************************************************/
/* 	  aisa54.dll[h												 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa54wDllOpen()
{
	if (hDLL != NULL)
		return FALSE;

	hDLL = (HMODULE)LoadLibrary(AISA54_DLL_NAME);
	if (hDLL == NULL)
		return FALSE;

	if (Aisa54wGetDllExportFunc() == FALSE)
	{
		Aisa54wDllClose();	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		return FALSE;
	}

	return TRUE;
}

/*****************************************************************************/
/* 	  aisa54.dllA[h											 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa54wDllClose()
{
	if (hDLL == NULL)
		return TRUE;

	if (FreeLibrary(hDLL) == TRUE)
	{
		hDLL = NULL;
		return TRUE;
	}

	return FALSE;
}

/*****************************************************************************/
/* 	  aISA-P54W/H DLL,Driver̃o[Wԍ擾						 */
/* 	  pdwDllVer DLLo[Wԍi[AhX						 */
/*		  pdwDrvVer Drivero[Wԍi[AhX					 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa54wGetVersion(PDWORD pdwDllVer, PDWORD pdwDrvVer)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa54GetVersion)(pdwDllVer, pdwDrvVer);
}

/*****************************************************************************/
/* 	  aISA-P54W/H̔Cӂ̃foCX̎gp錾							 */
/* 	  pwLogSlot	 gpfoCXi[AhX						 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa54wCreate(PWORD pwLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa54Create)(pwLogSlot);
}

/*****************************************************************************/
/* 	  aISA-P54W/H̔Cӂ̃foCX̎gpJ							 */
/* 	  wLogSlot gpfoCX											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa54wClose(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa54Close)(wLogSlot);
}

/*****************************************************************************/
/* 	  aISA-P54W/H̃|[g擾										 */
/* 	  wLogSlot	  ׂfoCX										 */
/*		  pdwNumPorts |[gi[AhX							 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa54wGetNumPorts(WORD wLogSlot, PDWORD pdwNumPorts)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa54GetNumPorts)(wLogSlot, pdwNumPorts);
}

/*****************************************************************************/
/* 	  wfoCX̃\[X擾									 */
/* 	  wLogSlot ׂfoCX											 */
/*		  pResInfo \[Xi[\̂̃AhX					 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa54wGetResource(WORD wLogSlot, PAISA54R pResInfo)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa54GetResource)(wLogSlot, pResInfo);
}

/*****************************************************************************/
/* 	  fBNV̏Ԃ擾										 */
/* 	  wLogSlot		ׂfoCX										 */
/*		  pdwDirections Ԃi[DWORD̃AhX						 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa54wGetDirections(WORD wLogSlot, PDWORD pdwDirections)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa54GetDirections)(wLogSlot, pdwDirections);
}

/*****************************************************************************/
/* 	  fBNVZbg											 */
/* 	  wLogSlot	   ZbgfoCX									 */
/*		  dwDirections Zbge										 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa54wSetDirections(WORD wLogSlot, DWORD dwDirections)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa54SetDirections)(wLogSlot, dwDirections);
}

/*****************************************************************************/
/* 	  Cӂ̃|[gf[^										 */
/* 	  wLogSlot	͂foCX										 */
/*		  dwPort	͂|[g											 */
/*		  pbInValue ̓f[^i[AhX							 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa54wInPort(WORD wLogSlot, DWORD dwPort, PBYTE pbInValue)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa54InPort)(wLogSlot, dwPort, pbInValue);
}

/*****************************************************************************/
/* 	  Cӂ̃|[gփf[^o										 */
/* 	  wLogSlot	o͂foCX										 */
/*		  dwPort	o͂|[g											 */
/*		  bOutValue o͂f[^											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa54wOutPort(WORD wLogSlot, DWORD dwPort, BYTE bOutValue)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa54OutPort)(wLogSlot, dwPort, bOutValue);
}

/*****************************************************************************/
/* 	  aISA-P54W/H̃G[R[h											 */
/* 	  wLogSlot	G[foCX								 */
/* ߂l G[R[h														 */
/*****************************************************************************/
DWORD Aisa54wGetLastError(WORD wLogSlot)
{
	if (hDLL == NULL)
		return AISA54_ERR_WRAPDLL;

	return (*pAisa54GetLastError)(wLogSlot);
}

/*---------------------------------------------------------------------------*/
/* 	  DLLGNX|[g֐AhX̎擾									 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*---------------------------------------------------------------------------*/
static BOOL Aisa54wGetDllExportFunc()
{
	// Aisa54GetVersion ̃AhX擾
	pAisa54GetVersion = GetProcAddress(hDLL, _T("Aisa54GetVersion"));
	if (pAisa54GetVersion == NULL)
		return FALSE;

	// Aisa54Create ̃AhX擾
	pAisa54Create = GetProcAddress(hDLL, _T("Aisa54Create"));
	if (pAisa54Create == NULL)
		return FALSE;

	// Aisa54Close ̃AhX擾
	pAisa54Close = GetProcAddress(hDLL, _T("Aisa54Close"));
	if (pAisa54Close == NULL)
		return FALSE;

	// Aisa54GetNumPorts ̃AhX擾
	pAisa54GetNumPorts = GetProcAddress(hDLL, _T("Aisa54GetNumPorts"));
	if (pAisa54GetNumPorts == NULL)
		return FALSE;

	// Aisa54GetResource ̃AhX擾
	pAisa54GetResource = GetProcAddress(hDLL, _T("Aisa54GetResource"));
	if (pAisa54GetResource == NULL)
		return FALSE;

	// Aisa54GetDirections ̃AhX擾
	pAisa54GetDirections = GetProcAddress(hDLL, _T("Aisa54GetDirections"));
	if (pAisa54GetDirections == NULL)
		return FALSE;

	// Aisa54SetDirections ̃AhX擾
	pAisa54SetDirections = GetProcAddress(hDLL, _T("Aisa54SetDirections"));
	if (pAisa54SetDirections == NULL)
		return FALSE;

	// Aisa54InPort ̃AhX擾
	pAisa54InPort = GetProcAddress(hDLL, _T("Aisa54InPort"));
	if (pAisa54InPort == NULL)
		return FALSE;

	// Aisa54OutPort ̃AhX擾
	pAisa54OutPort = GetProcAddress(hDLL, _T("Aisa54OutPort"));
	if (pAisa54OutPort == NULL)
		return FALSE;

	// Aisa54GetLastError ̃AhX擾
	pAisa54GetLastError = GetProcAddress(hDLL, _T("Aisa54GetLastError"));
	if (pAisa54GetLastError == NULL)
		return FALSE;

	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
